Summary: The most widely used IRC server (on IRCnet for instance)
Name: ircd
Version: 2.10.3p1
Release: 3
Serial: 0
Copyright: GPL
Group: System Environment/Daemons
Source0: ftp://ftp.irc.org/irc/server/irc%{version}.tgz
Source1: ircd.init
Source2: irc%{version}-config.h
Source3: ircd_crypter
URL: http://www.irc.org/
Requires: initscripts >= 5.49
BuildRoot: %{_tmppath}/%{name}-root
PreReq: /sbin/chkconfig, /sbin/service

# Needed so the package doesn't provide all the glibc libs!
AutoReqProv: no
Provides: ircd

%define _chroot /var/ircd

%description
ircd is the server (daemon) program for the Internet Relay Chat Program.
The ircd is a server in that its function is to "serve" the client program
irc(1) with messages and commands. All commands and user messages are
are passed directly to the ircd for processing and relaying to other ircd
sites.

%prep
%setup -n irc%version

%build
export CFLAGS=$RPM_OPT_FLAGS
./configure \
	--prefix=%{_prefix} \
	--libdir=%{_chroot} \
	--localstatedir=/run \
	--sysconfdir=/etc/ircd \
	--logdir=/log \
	--mandir=%{_mandir} \
	--with-zlib \
	--disable-ipv6
MYARCH=`support/config.guess`
install -m 644 %{SOURCE2} $MYARCH/config.h
# make everything except the client
make -C $MYARCH ircd iauth chkconf ircd-mkpasswd
make -C $MYARCH ircdwatch ircd_var_dir=%{_chroot}/run

%install
rm -rf $RPM_BUILD_ROOT
make -C `support/config.guess` prefix=$RPM_BUILD_ROOT%{_prefix} \
	server_man_dir=$RPM_BUILD_ROOT%{_mandir}/man8 \
	conf_man_dir=$RPM_BUILD_ROOT%{_mandir}/man5 \
	ircd_dir=$RPM_BUILD_ROOT%{_chroot} \
	ircd_conf_dir=$RPM_BUILD_ROOT%{_chroot}/etc/ircd \
	ircd_var_dir=$RPM_BUILD_ROOT%{_chroot}/run \
	ircd_log_dir=$RPM_BUILD_ROOT%{_chroot}/log \
	install-server

mkdir -p $RPM_BUILD_ROOT%{_chroot}/{etc,lib,usr/sbin,log,run}
install -D -m 711 %{SOURCE3} $RPM_BUILD_ROOT%{_sbindir}/ircd-crypter
install -D -m 755 $RPM_SOURCE_DIR/ircd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/ircd

echo 'This is a poorly installed IRC server (MOTD not edited)' \
	> $RPM_BUILD_ROOT%{_chroot}/etc/ircd/ircd.motd
touch $RPM_BUILD_ROOT%{_chroot}/etc/resolv.conf
mv $RPM_BUILD_ROOT%{_chroot}/etc/ircd/example.conf \
	$RPM_BUILD_ROOT%{_chroot}/etc/ircd/ircd.conf.dist
cp $RPM_BUILD_ROOT%{_chroot}/etc/ircd/ircd.conf.dist \
	$RPM_BUILD_ROOT%{_chroot}/etc/ircd/ircd.conf

# Chroot-related
mv $RPM_BUILD_ROOT/usr/sbin/iauth $RPM_BUILD_ROOT%{_chroot}/usr/sbin
ln -sf ../..%{_chroot}/usr/sbin/iauth $RPM_BUILD_ROOT/usr/sbin

ln -sf ..%{_chroot}/etc/ircd $RPM_BUILD_ROOT/etc/ircd

# Borrowed from anonftp
cat > $RPM_BUILD_ROOT%{_chroot}/etc/passwd << EOF
root:*:0:0:::
bin:*:1:1:::
EOF

cat > $RPM_BUILD_ROOT%{_chroot}/etc/group << EOF
root::0:
bin::1:
daemon::2:
sys::3:
adm::4:
EOF

%define LDSOVER 2
%define LIBCVER 2.2
%define LIBCRYPTVER 1
%define LIBNSLVER 1
%define LIBNSSVER 2
%define LIBCSOVER 6

%define _chlib $RPM_BUILD_ROOT%{_chroot}/lib

cp -fd /etc/ld.so.cache $RPM_BUILD_ROOT%{_chroot}/etc
cp -fd /lib/libc.so.%{LIBCSOVER} /lib/libc-%{LIBCVER}.so	%{_chlib}
cp -fd /lib/ld-linux.so.%{LDSOVER} /lib/ld-%{LIBCVER}.so	%{_chlib}
cp -fd /lib/libcrypt-%{LIBCVER}.so \
	/lib/libcrypt.so.%{LIBCRYPTVER}				%{_chlib}
cp -fd /lib/libnsl-%{LIBCVER}.so \
	/lib/libnsl.so.%{LIBNSLVER}				%{_chlib}
cp -fd /lib/libnss_compat-%{LIBCVER}.so \
	/lib/libnss_compat.so.%{LIBNSSVER}			%{_chlib}
cp -fd /lib/libnss_dns-%{LIBCVER}.so \
	/lib/libnss_dns.so.%{LIBNSSVER}				%{_chlib}
cp -fd /lib/libnss_files-%{LIBCVER}.so \
	/lib/libnss_files.so.%{LIBNSSVER}			%{_chlib}
cp -fd /lib/libresolv-%{LIBCVER}.so \
	/lib/libresolv.so.%{LIBNSSVER}				%{_chlib}

strip %{_chlib}/*

%post
/sbin/chkconfig --add ircd
# Make the resolver happy
install -m 644 /etc/resolv.conf %{_chroot}/etc
# Touch the log files
touch %{_chroot}/log/auth
touch %{_chroot}/log/opers
touch %{_chroot}/log/rejects
touch %{_chroot}/log/users
chmod 640 %{_chroot}/log/*

%preun
if [ $1 = 0 ] ; then
	/sbin/service ircd stop >/dev/null 2>&1
	rm -f /var/ircd/run/*
	/sbin/chkconfig --del ircd
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%doc doc/*
/etc/rc.d/init.d/ircd
/etc/ircd
%{_mandir}/*/*
%{_sbindir}/*
%attr(750, root, root) %dir %{_chroot}
%{_chroot}/lib
%dir %{_chroot}/etc
%dir %{_chroot}/usr
%{_chroot}%{_prefix}/sbin
%{_chroot}/etc/ld.so.cache
%attr(444,root,root) %config %{_chroot}/etc/passwd
%attr(444,root,root) %config %{_chroot}/etc/group
%ghost %{_chroot}/etc/resolv.conf
%attr(750, root, root) %config %dir %{_chroot}/etc/ircd
%config(noreplace) %{_chroot}/etc/ircd/ircd.conf
%config %{_chroot}/etc/ircd/ircd.conf.dist
%config(noreplace) %{_chroot}/etc/ircd/iauth.conf
%{_chroot}/etc/ircd/ircd.m4
%config(noreplace) %{_chroot}/etc/ircd/ircd.motd
%dir %{_chroot}/log
%dir %{_chroot}/run

%changelog
* Fri Jan  5 2001 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fixed the autoprovides problem

* Thu Dec 28 2000 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fixed some dependencies (PreReq)
- Added %clean (oops!)

* Sat Dec 23 2000 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Remade the spec file rot RPM v4 (nice work from Mihai though!)
- Included doc/* instead of doc for %doc
- Changed the init script for RedHat 7.0
- Better uninstall/upgrade capability
- General cleanup (a lot of work :-)

* Wed Jan 13 1999 Mihai Ibanescu <misa@necomm.ro>
- Last cleanups before the release of the package in the real world

